/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author WILLY KASHALA
 */
public class SQLQueryContentieux {

    public static String SELECT_AMR_BY_NUMERO = "SELECT AM.* FROM T_AMR AM  WITH(READPAST)"
            + " INNER JOIN T_FICHE_PRISE_CHARGE PC WITH(READPAST) ON PC.CODE = AM.FICHE_PRISE_CHARGE"
            + " INNER JOIN T_PERSONNE P WITH(READPAST) ON P.CODE = PC.PERSONNE"
            + " INNER JOIN T_FORME_JURIDIQUE FJ WITH(READPAST) ON FJ.CODE = P.FORME_JURIDIQUE"
            + " WHERE AM.NUMERO = ?1 AND P.CODE = ?2 AND P.ETAT = 1 AND PC.ETAT = 2 "
            + " AND AM.PAYER = 0 AND isnull(AM.EN_CONTENTIEUX,0) = 0 AND AM.ETAT > 0 ";

    public static String SELECT_RECLAMATION_BY_REFERENCE_DOCUMENT = "SELECT TOP 1 R.* FROM T_RECLAMATION R "
            + " WITH (READPAST) WHERE R.ID IN  (SELECT DISTINCT DR.FK_RECLAMATION FROM T_DETAILS_RECLAMATION DR"
            + " WITH (READPAST) WHERE DR.REFERENCE_DOCUMENT = ?1)";
    
     public static String SELECT_RECLAMATION_BY_REFERENCE_DOCUMENT_AND_ASSUJETTI = "SELECT TOP 1 R.* FROM T_RECLAMATION R "
            + " WITH (READPAST) WHERE R.ID IN  (SELECT DISTINCT DR.FK_RECLAMATION FROM T_DETAILS_RECLAMATION DR"
            + "  WITH (READPAST) WHERE DR.FK_DECISION IS NOT NULL AND DR.DATE_TRAITEMENT IS NOT NULL) "
             + " AND R.ID = ?1 AND R.FK_PERSONNE = ?2 AND R.EST_TRAITER <> 3";
     
     public static String SELECT_RECLAMATION_BY_REFERENCE_DOCUMENT_AND_ASSUJETTI_V2 = "SELECT TOP 1 R.* FROM T_RECLAMATION R "
            + " WITH (READPAST) WHERE R.ID IN  (SELECT DISTINCT DR.FK_RECLAMATION FROM T_DETAILS_RECLAMATION DR"
            + "  WITH (READPAST) WHERE DR.FK_DECISION IS NULL AND DR.DATE_TRAITEMENT IS NULL) "
            + " AND R.ID = ?1 AND R.FK_PERSONNE = ?2 AND R.EST_TRAITER <> 3"
            + " AND R.ID IN (SELECT DRS.FK_RECLAMATION FROM T_DETAILS_RECLAMATION DRS WITH (READPAST)"
            + " JOIN T_AMR AM WITH (READPAST) ON AM.NUMERO = DRS.REFERENCE_DOCUMENT"
            + " JOIN T_BON_A_PAYER BP WITH (READPAST) ON BP.FK_AMR = AM.NUMERO"
            + " JOIN T_SUIVI_COMPTABLE_DECLARATION SC WITH (READPAST) ON SC.DOCUMENT_REFERENCE = BP.CODE)";

    public static String SELECT_ARTICLE_BUDGETAIRE_BY_FPC = "SELECT TOP 1 DFP.* FROM T_DETAIL_FICHE_PRISE_CHARGE DFP WITH (READPAST) "
            + " WHERE DFP.FICHE_PRISE_CHARGE = ?1";

    public static String LOADER_AMR_BY_NUMERO = "SELECT AM.* FROM T_AMR AM  WITH(READPAST) "
            + " WHERE AM.NUMERO = ?1 AND AM.ETAT > 0 ";
    
    public static String LOADER_AMR_BY_NUMERO_V2 = "SELECT AM.* FROM T_AMR AM  WITH(READPAST) "
            + " WHERE AM.NUMERO = ?1 ";
    
    public static String SELECT_BON_A_PAYER_BY_AMR = "SELECT BP.* FROM T_BON_A_PAYER BP  WITH(READPAST) "
            + " WHERE BP.FK_AMR = ?1 AND BP.TYPE_BP = 2 ";
    
    public static String GET_AMR_CLOTURER = "SELECT AM.* FROM T_AMR AM  WITH(READPAST) "
            + " WHERE AM.NUMERO = ?1 AND AM.ETAT = 0 ";

    public static String SELECT_SUIVI_COMPTABLE_BY_NC = "SELECT TOP 1 SC.* FROM T_SUIVI_COMPTABLE_DECLARATION SC WITH (READPAST) "
            + " WHERE SC.NC = ?1";

    public static String SAVE_RECLAMATION = "F_NEW_RECLAMATION2";

    public static String F_NEW_DETAILS_RECLAMATION = ":EXEC F_DETALS_RECLAMMATION ?1,?2,?3,?4,?5,?6,'%s'";

    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_CODE_ASSUJETTI = " DR.FK_RECLAMATION =  (SELECT R.ID FROM T_RECLAMATION R WITH (READPAST)"
            + " WHERE R.ETAT_RECLAMATION = 2 AND R.FK_PERSONNE = ?1)";
    
    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_CODE_ASSUJETTI_V4 = " RJ.FK_RECLAMATION =  (SELECT R.ID FROM T_RECLAMATION R WITH (READPAST)"
            + " WHERE R.FK_PERSONNE = ?1)";
    
    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_CODE_ASSUJETTI_V2 = " AND RJ.FK_RECLAMATION =  (SELECT R.ID FROM T_RECLAMATION R WITH (READPAST)"
            + " WHERE R.ETAT_RECLAMATION = 2 AND R.FK_PERSONNE = ?1 AND R.ETAT = 1)";
    
    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_CODE_ASSUJETTI_V3 = " RJ.FK_RECLAMATION =  (SELECT R.ID FROM T_RECLAMATION R WITH (READPAST)"
            + " WHERE R.FK_PERSONNE = ?1)";

    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_REFERENCE_COURRIER = " R.REFERENCE_COURIER_RECLAMATION = ?1";
    
    public static String SQL_QUERY_SECONDARY_RECOURS_BY_NUMERO_REGISTRE = " RJ.NUMERO_ENREGISTREMENT_GREFFE = ?1";

    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_REFERENCE_DOCUMENT = " R.ID IN (SELECT DISTINCT "
            + " DR.FK_RECLAMATION FROM T_DETAILS_RECLAMATION DR WITH (READPAST) "
            + " WHERE DR.REFERENCE_DOCUMENT = ?1)";
    
    public static String SQL_QUERY_SECONDARY_RECOURS_BY_REFERENCE_DOCUMENT = " RJ.FK_RECLAMATION = ?1 ";

    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_DATES = " DBO.FDATE(R.DATE_CREAT) BETWEEN '%s' AND '%s'";
    
    public static String SQL_QUERY_SECONDARY_RECOURS_BY_DATE = " AND DBO.FDATE(RJ.DATE_CREAT) BETWEEN '%s' AND '%s'";
    
    public static String SQL_QUERY_SECONDARY_RECOURS_BY_DATE_V2 = " DBO.FDATE(RJ.DATE_CREAT) BETWEEN '%s' AND '%s'";

    public static String SQL_QUERY_SECONDARY_RECLAMATION_BY_TYPE_RECLAMATION = " AND R.TYPE_RECLAMATION = '%s'";

    public static String SELECT_LIST_MASTER_RECLAMATION = "SELECT R.* FROM T_RECLAMATION R WITH (READPAST)"
            + " INNER JOIN T_DETAILS_RECLAMATION DR WITH (READPAST) ON R.ID = DR.FK_RECLAMATION"
            + " INNER JOIN T_AMR A WITH (READPAST)ON DR.REFERENCE_DOCUMENT = A.NUMERO"
            + "  WHERE %s %s %s %s %s AND EST_TRAITER = 0 AND A.ETAT = 2";
    
    public static String SELECT_LIST_MASTER_RECLAMATION_V2 = "SELECT R.* FROM T_RECLAMATION R WITH (READPAST)"
            + " INNER JOIN T_DETAILS_RECLAMATION DR WITH (READPAST) ON R.ID = DR.FK_RECLAMATION"
            + " INNER JOIN T_AMR A WITH (READPAST)ON DR.REFERENCE_DOCUMENT = A.NUMERO"
            + "  WHERE %s %s %s %s %s ";
    
    public static String SELECT_LIST_MASTER_RECOURS_JURIDICTIONNEL = "SELECT RJ.* FROM T_RECOURS_JURIDICTIONNEL "
            + "RJ WITH (READPAST) WHERE RJ.ETAT = 1 %s %s %s %s";
    
    public static String SELECT_LIST_MASTER_RECOURS_JURIDICTIONNEL_V2 = "SELECT RJ.* FROM T_RECOURS_JURIDICTIONNEL "
            + "RJ WITH (READPAST) WHERE %s %s %s %s";

    public static String SELECT_RECLAMATION_BY_ID = "SELECT R.* FROM T_RECLAMATION R WITH (READPAST) WHERE R.ID = ?1";

    public static String SELECT_DETAIL_RECLAMATION_BY_FK_RECLAMATION = "SELECT DR.* FROM T_DETAILS_RECLAMATION DR WITH (READPAST) "
            + " WHERE DR.FK_RECLAMATION = ?1";

    public static String SELECT_DECISION_BY_ID = "SELECT D.* FROM T_DECISION D WITH (READPAST) WHERE D.ID = ?1";

    public static String SELECT_SERVICE_BY_CODE = "SELECT TOP 1 SVC.* FROM T_SERVICE SVC WITH (READPAST) "
            + " WHERE SVC.CODE = ?1";

    public static String CHECK_RECLAMATION = "SELECT R.* FROM T_RECLAMATION R WITH (READPAST) WHERE R.ID = ?1 AND R.ETAT = 1";

    public static String SELECT_AGENT_BY_CODE = "SELECT A.* FROM T_AGENT A WITH (READPAST) WHERE A.CODE = ?1 AND A.ETAT = 1";

    public static String SELECT_JOURNAL_BY_DOCUMENT_APURE = "SELECT J.* FROM T_JOURNAL J WITH (READPAST) WHERE J.DOCUMENT_APURE = ?1";
    
    public static String LOADER_DETAIL_NC_BY_NC = "SELECT TOP 1 NC.* FROM T_DETAILS_NC NC  WITH(READPAST) " 
            + " WHERE NC.NOTE_CALCUL = ?1";
    
      public static String SELECT_SECOURS_JURIDICTIONNEL_BY_RECLEMATION = "SELECT RJ.* FROM T_RECOURS_JURIDICTIONNEL RJ  WITH(READPAST) "
            + " WHERE RJ.FK_RECLAMATION = ?1";
      
       public static String SELECT_LIST_ARCHIVE_BY_REFERENCE = "SELECT * FROM T_ARCHIVE_ACCUSE_RECEPTION AR  WITH (READPAST) "
            + " WHERE AR.DOCUMENT_REFERENCE = ?1";

    public static class ExecuteQuery {

        public static String EXEC_NEW_DOSSIER_WEB = ":EXEC F_NEW_DOSSIER_WEB ?1,?2,?3,?4,?5";

        public static String EXEC_F_NEW_BON_A_PAYER_CONTENTIEUX = ":EXEC F_NEW_BON_A_PAYER_WEB_V2 ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11";

        public static String VALIDER_RECLAMATION = ":EXEC F_UPDATE_RECLAMATION ?1,?2,?3";

        public static String UPDATE_BP_PRINT = ":UPDATE T_BON_A_PAYER SET ETAT_IMPRESSION = 1 "
                + " WHERE CODE = ?1  ";

        public static String F_SIMPLE_TRAITEMENT_RECLAMATION = ":UPDATE T_DETAILS_RECLAMATION SET AGENT_TRAITEMENT = ?1,"
                + " DATE_TRAITEMENT = GETDATE(), FK_DECISION = ?2 WHERE ID = ?3";
        
        public static String F_SIMPLE_TRAITEMENT_JURIDICTIONNEL = ":UPDATE T_DETAILS_RECLAMATION SET AGENT_TRAITEMENT_JURIDIQUE = ?1,"
                + " DATE_TRAITEMENT_JURIDIQUE = GETDATE(), FK_DECISION_JURIDIQUE = ?2 WHERE ID = ?3";
        
        public static String UPDATE_TRAITEMENT_RECLAMATION = ":UPDATE T_RECLAMATION SET EST_TRAITER = ?2"
                + " WHERE ID = ?1";
        public static String UPDATE_TRAITEMENT_RECLAMATION_V2 = ":UPDATE T_RECLAMATION SET EST_TRAITER = ?2,"
                + " ETAT = ?3 WHERE ID = ?1";
        
        public static String UPDATE_RECOURS_JURIDICTIONNEL = ":UPDATE T_RECOURS_JURIDICTIONNEL SET ETAT = ?2"
                + " WHERE ID = ?1";
        
        public static String UPDATE_BON_A_PAYER_ADMIN = ":UPDATE T_BON_A_PAYER SET TYPE_BP = ?2, ETAT = 0"
                + " WHERE CODE = ?1";

        public static String F_UPDATE_DECISION_JURIDIQUE = ":UPDATE T_DETAILS_RECLAMATION SET FK_DECISION_JURIDIQUE = ?1,"
                + " DATE_TRAITEMENT_JURIDIQUE = GETDATE() WHERE ID = ?2";

        public static String F_DEGREVEMENT_PARTIEL_BON_A_PAYER = ":UPDATE T_BON_A_PAYER SET ETAT = 13 "
                + " WHERE CODE = ?1";

        public static String F_UPDATE_AMR = ":UPDATE T_AMR SET ETAT = ?1 "
                + " WHERE NUMERO = ?2";

        public static String ARCHIVE_ACCUSER_RECEPTION2 = ":EXEC F_NEW_ARCHIVE_ACCUSE_RECEPTION ?1,?2,?3,?4,?5";
        
        public static String F_NEW_RECOURS_JURIDICTIONNEL = "EXEC F_NEW_RECOURS_JURIDICTIONNEL ?1,?2,?3,?4,?5,?6";
    }
}
